## dde-introduction 5.6.35

=== CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     V4fr3e <V4fr3e@deepin.io>
#
# Maintainer: V4fr3e <liujinli@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.7)
set(PROJECT_VERSION "5.9.0.53")

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

ADD_COMPILE_OPTIONS(-fno-access-control)

#set different ISO types
#1:professional 2:community 3:server
#set(ISO_TYPE "professional")
set(ISO_TYPE "community")
#set(ISO_TYPE "server")

#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/resources")
set(APP_BIN_NAME "dde-introduction")
set(APP_TRANS_SCRIPT "${CMAKE_SOURCE_DIR}/translate_generation.sh")
set(APP_DESKTOP "${CMAKE_SOURCE_DIR}/dde-introduction.desktop")
set(APP_QRC "${CMAKE_SOURCE_DIR}/dde-introduction.qrc")
set(APP_LOGO "${APP_RES_DIR}/dde-introduction.svg")

#Check if APP_TS_UPDATE var isn't set, don't need update ts file
if (NOT DEFINED APP_TS_UPDATE)
   set(APP_TS_UPDATE false)
endif()

#Only update ts file when APP_TS_UPDATE=true
if (${APP_TS_UPDATE} STREQUAL "true")
    set(APP_TS_UPDATE true)
endif()

project(${APP_BIN_NAME})

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
elseif (${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DISLOONGARCH64")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

execute_process(COMMAND bash
                    ${APP_TRANS_SCRIPT}
                    translations
                    ${APP_TS_UPDATE}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${APP_BIN_NAME}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${CMAKE_CURRENT_LIST_DIR}/src/environments.h.in ${CMAKE_CURRENT_LIST_DIR}/src/environments.h @ONLY)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/src)

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/${subdir})
endforeach()

file(GLOB_RECURSE CPP_SRC ${CMAKE_SOURCE_DIR}/src/*.cpp)


# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5 COMPONENTS DBus Sql Multimedia REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkCore REQUIRED)
find_package(DFrameworkdbus REQUIRED)

include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    pkg_check_modules(LIBDMR REQUIRED libdmr)
    include_directories(${LIBDMR_INCLUDE_DIRS})
else()
    ADD_DEFINITIONS("-D DISABLE_VIDEO")
    LIST(REMOVE_ITEM CPP_SRC ${CMAKE_CURRENT_LIST_DIR}/src/modules/videowidget.cpp)
endif()


# Tell CMake to create the executable
add_executable(${PROJECT_NAME} ${CPP_SRC} ${APP_QRC})

target_include_directories(${APP_BIN_NAME}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})

target_link_libraries(${APP_BIN_NAME}
    ${DtkCore_LIBRARIES}
    ${DFrameworkdbus_LIBRARIES}
    ${GSTREAMER_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Multimedia
)

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    target_link_libraries(${APP_BIN_NAME} ${LIBDMR_LIBRARIES})
endif()


set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(TARGETS dde-introduction DESTINATION bin)

file(GLOB APP_QM_FILES "${CMAKE_SOURCE_DIR}/translations/*.qm")
file(GLOB_RECURSE ASS_SRC ${CMAKE_SOURCE_DIR}/resources/video/*.ass)

#Choose different videos for different ISO types
if(ISO_TYPE MATCHES "server")
set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/server/demo.mp4)
elseif(ISO_TYPE MATCHES "community")
set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/community/demo.mp4)
else()
set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/professional/demo.mp4)
endif()

#代码覆盖率开关
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

file(GLOB_RECURSE DEMO_VIDEO_SRC ${VIDEO_PATH})

install(FILES ${APP_QM_FILES} DESTINATION /usr/share/dde-introduction/translations)
install(FILES ${APP_DESKTOP} DESTINATION /usr/share/applications)
install(FILES ${APP_LOGO} DESTINATION  ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)
install(FILES ${ASS_SRC} DESTINATION /usr/share/dde-introduction/)
install(FILES ${DEMO_VIDEO_SRC} DESTINATION /usr/share/dde-introduction/)
#add ut test
add_subdirectory(tests)

=== debian/changelog ===
dde-introduction (5.6.35-1) unstable; urgency=medium

 * Non-maintainer upload.
 * 

  [ Deepin Packages Builder ]
  * update

 -- Deepin Packages Builder <packages@deepin.org>  Sat, 26 Mar 2022 18:36:08 +0800

dde-introduction (5.6.0.41) unstable; urgency=medium

 * 修复无法切换特效模式的问题；
 * 更新视频；                                
 
-- Deepin Packages Builder <packages@deepin.com>  Wed, 11 Oct 2017 17:38:35 +0800

=== debian/control ===
Source: dde-introduction
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends: debhelper (>= 9),
 pkg-config,
 cmake,
 libdtkgui-dev,
 libdtkwidget-dev,
 libdframeworkdbus-dev,
 libdmr-dev,
 libffmpegthumbnailer-dev,
 libdtkcore-dev,
 libdtkcore5-bin,
 qttools5-dev,
 libgsettings-qt-dev,
 qtmultimedia5-dev,
 libgtest-dev, 
 libgmock-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: dde-introduction
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Introduction for UOS
 When you log into the system for the first time, a welcome program will automatically start.    
 Watch the introduction video to get new features, customize your desktop, enable the window 
 effect and know more about UnionTech OS.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_SAFETYTEST_ARG="CMAKE_SAFETYTEST_ARG_OFF" \
  	  -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

## dde-introduction 5.6.38

=== CMakeLists.txt ===
--- 
+++ 
@@ -195,6 +195,6 @@
 install(FILES ${ASS_SRC} DESTINATION /usr/share/dde-introduction/)
 install(FILES ${DEMO_VIDEO_SRC} DESTINATION /usr/share/dde-introduction/)
 #add ut test
-add_subdirectory(tests)
-
-
+#add_subdirectory(tests)
+
+

=== tests/CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     zhangteng <zhangteng@uniontech.com>
#
# Maintainer: zhangteng <zhangteng@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(APP_QRC "../dde-introduction.qrc")

ADD_COMPILE_OPTIONS(-fno-access-control)

# 设置添加gocv相关信息的输出
set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")

find_package(Qt5Test REQUIRED)
find_package(GTest REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(src)

set(PROJECT_NAME_TEST
    ${PROJECT_NAME}-test)

#Include all app own subdirectorys

file(GLOB_RECURSE INTRODUCTION_SRC_TEST ${CMAKE_CURRENT_LIST_DIR}/../src/*.cpp)
file(GLOB_RECURSE INTRODUCTION_SRC_TEST1 ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)

list(REMOVE_ITEM INTRODUCTION_SRC_TEST "${CMAKE_CURRENT_LIST_DIR}/../src/main.cpp")
#ADD_DEFINITIONS("-D DISABLE_VIDEO")
#LIST(REMOVE_ITEM INTRODUCTION_SRC_TEST "${CMAKE_CURRENT_LIST_DIR}/../src/modules/videowidget.cpp")
#LIST(REMOVE_ITEM INTRODUCTION_SRC_TEST1 "${CMAKE_CURRENT_LIST_DIR}/src/modules/ut_videowidget.cpp")


if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    ADD_DEFINITIONS("-D DISABLE_VIDEO")
    LIST(REMOVE_ITEM INTRODUCTION_SRC_TEST ${CMAKE_CURRENT_LIST_DIR}/../src/modules/videowidget.cpp)
    LIST(REMOVE_ITEM INTRODUCTION_SRC_TEST1 ${CMAKE_CURRENT_LIST_DIR}/src/modules/ut_videowidget.cpp)
endif()

# 生成测试可执行程序
add_executable(${PROJECT_NAME_TEST}
    ${INTRODUCTION_SRC_TEST}
    ${INTRODUCTION_SRC_TEST1}
    ${APP_QRC}
    )

# 生成测试可执行程序的依赖库QApplication
target_link_libraries(${PROJECT_NAME_TEST} 
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DFrameworkdbus_LIBRARIES}
    ${GSTREAMER_LIBRARIES}
    ${LIBDMR_LIBRARIES}
    ${GTEST_LIBRARYS}
    ${GTEST_MAIN_LIBRARYS}
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Multimedia
    gtest
    gtest_main
    -pthread
)

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    pkg_check_modules(LIBDMR REQUIRED libdmr)
    include_directories(${LIBDMR_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME_TEST} ${LIBDMR_LIBRARIES})
endif()

target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${DtkWidget_INCLUDE_DIRS}
                                                       ${DtkCore_INCLUDE_DIRS}
                                                       ${DtkGui_INCLUDE_DIRS})

# ------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test)
add_custom_command(TARGET test
    COMMAND echo " =================== TEST BEGIN ==================== "
    COMMAND ${PROJECT_NAME_TEST}
    )
add_dependencies(test ${PROJECT_NAME_TEST})

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

#ASAN安全性检测标志
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

=== debian/changelog ===
dde-introduction (5.6.38-1) unstable; urgency=medium

 * Non-maintainer upload.
 * 

  [ Deepin Packages Builder ]
  * update

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 28 Sep 2022 13:27:13 +0800

## dde-introduction 6.5.17.1

=== debian/changelog ===
dde-introduction (6.5.17.1) unstable; urgency=medium

  * chore: update desktop file
  * fix: update deepin videos(Bug: 311619)
  * fix: crash when play in virtual machine(Bug: 311635)

 -- renbin <renbin@uniontech.com>  Wed, 09 Apr 2025 11:14:32 +0800

dde-introduction (6.5.17) unstable; urgency=medium

  * Update version to 6.5.17

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 20 Mar 2025 19:10:48 +0800

dde-introduction (6.5.16) unstable; urgency=medium

  * Update version to 6.5.16

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 13 Mar 2025 10:21:50 +0800

dde-introduction (6.5.15) unstable; urgency=medium

  * Update version to 6.5.15

 -- xiepengfei <xiepengfei@uniontech.com>  Wed, 12 Mar 2025 20:19:46 +0800

dde-introduction (6.5.14) unstable; urgency=medium

  * Update version to 6.5.14

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 27 Feb 2025 19:24:26 +0800

dde-introduction (6.5.13) unstable; urgency=medium

  * Update version to 6.5.13
  * Update linglong.yaml for qt6.8 runtime.

 -- wangrong <wangrong@uniontech.com>  Fri, 07 Feb 2025 09:28:54 +0800

dde-introduction (6.5.12) unstable; urgency=medium

  * chore: v6.5.12 release.
  * feat: Support Qt6 build.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 16:30:43 +0800

dde-introduction (6.5.11) unstable; urgency=medium

  * fix: avoid black line on titlebar(Bug: 295281)

 -- renbin <renbin@uniontech.com>  Thu, 02 Jan 2025 20:37:45 +0800

dde-introduction (6.5.10) unstable; urgency=medium

  * chore: replace video footag
  * fix: optimize ui details(Bug: 294093)
  * fix: avoid black line on titlebar(Bug: 295281)
  * fix: remove margin while siwtch video(Bug: 294099)
  * fix: set dock mode not work(Bug: 297827)

 -- renbin <renbin@uniontech.com>  Fri, 27 Dec 2024 11:11:40 +0800

dde-introduction (6.5.9) unstable; urgency=medium

  * chore: Bump version to 6.5.9

 -- xiepengfei <xiepengfei@uniontech.com>  Sat, 14 Dec 2024 13:45:11 +0800

dde-introduction (6.5.8) unstable; urgency=medium

  * chore: Bump version to 6.5.8

 -- wangrong <wangrong@uniontech.com>  Mon, 09 Dec 2024 10:04:23 +0800

dde-introduction (6.5.7) unstable; urgency=medium

  * chore: Adapt linglong for loong64(Task: 368689)
  * fix: Welcome to new demand
  * feat: 2500 new design
  * chore: update translations
  * fix: mute previous video / hide button(Task: 35813)(Influence: UI)
  * feat: set video mute by default(Task: 35813)

 -- renbin <renbin@uniontech.com>  Sat, 07 Dec 2024 12:02:01 +0800

dde-introduction (6.5.6) unstable; urgency=medium

  * Update version to 6.5.6

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 18:50:36 +0800

dde-introduction (6.5.5) unstable; urgency=medium

  * New Version 6.5.5.

 -- xiepengfei <xiepengfei@uniontech.com>  Sat, 30 Nov 2024 14:02:10 +0800

dde-introduction (6.5.4) unstable; urgency=medium

  * fix fail to start linglong app by launcher.

 -- wangrong <wangrong@uniontech.com>  Sat, 16 Nov 2024 15:18:50 +0800

dde-introduction (6.5.3) unstable; urgency=medium

  * remove kwayland-shell env

 -- Liu zheng <liuzheng@uniontech.com>  Mon, 11 Nov 2024 09:46:30 +0800

dde-introduction (6.5.2) unstable; urgency=medium

  * chore: linglong package slimming.

 -- wangrong <wangrong@uniontech.com>  Mon, 21 Oct 2024 14:44:59 +0800

dde-introduction (6.5.1) unstable; urgency=medium

  * New version 6.5.1
  * Adapt linglong.

 -- re2zero <yangwu@uniontech.com>  Fri, 13 Sep 2024 14:06:16 +0800

dde-introduction (6.5.0) unstable; urgency=medium

  * update version 6.5.0.

 -- xiepengfei <xiepengfei@uniontech.com>  Wed, 21 Aug 2024 14:52:33 +0800

dde-introduction (6.0.22) unstable; urgency=medium

  * update version

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 25 Apr 2024 18:00:32 +0800

dde-introduction (6.0.21) unstable; urgency=medium

  * update version

 -- liuzheng <liuzheng@uniontech.com>  Tue, 16 Apr 2024 21:29:42 +0800

dde-introduction (6.0.20) unstable; urgency=medium

  * New Version 6.0.20.

 -- xiepengfei <xiepengfei@uniontech.com>  Tue, 16 Apr 2024 19:50:33 +0800

dde-introduction (6.0.19) unstable; urgency=medium

  * New Version 6.0.19.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 12 Apr 2024 16:49:15 +0800

dde-introduction (6.0.18) unstable; urgency=medium

  * fix: Fix window color change

 -- renbin <renbin@uniontech.com>  Wed, 03 Apr 2024 16:30:08 +0800

dde-introduction (6.0.17) unstable; urgency=medium

  * chore: Optimization of display effects for commonly used application icons
  * feat: New fetures
  * fix: Dark theme problem (Bug: 247971)
  * fix: The interface switching lag problem (Bug: 243765)
  * fix: The white edges in the playback interface(Bug: 245133)

 -- renbin <renbin@uniontech.com>  Wed, 27 Mar 2024 16:15:49 +0800

dde-introduction (6.0.16) unstable; urgency=medium

  * fix: Fix the issue of incomplete text display in commonly used applicationsBug: 245381)

 -- houchengqiu <houchengqiu@uniontech.com>  Wed, 13 Mar 2024 15:18:12 +0800

dde-introduction (6.0.15) unstable; urgency=medium

  * New Version 6.0.15.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 01 Mar 2024 17:58:07 +0800

dde-introduction (6.0.14) unstable; urgency=medium

  * New Version 6.0.14.

 -- xiepengfei <xiepengfei@uniontech.com>  Tue, 27 Feb 2024 17:17:40 +0800

dde-introduction (6.0.13) unstable; urgency=medium

  * New Version 6.0.13.

 -- xiepengfei <xiepengfei@uniontech.com>  Web, 01 Feb 2024 16:16:24 +0800

dde-introduction (6.0.12) unstable; urgency=medium

  * feat: Modified the Welcome 1070 interface

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 19 Jan 2024 11:19:32 +0800

dde-introduction (6.0.11) unstable; urgency=medium

  * fix: click next to crash when logging in for the first time

 -- fengli <fengli@uniontech.com>  Fri, 03 Nov 2023 13:16:14 +0800

dde-introduction (5.7.3-1) unstable; urgency=medium

 * New Version 5.7.3.

 -- xiepengfei <xiepengfei@uniontech.com>  Tue, 18 Jul 2023 13:08:42 +0800

dde-introduction (5.7.2-1) unstable; urgency=medium

 * New Version 5.7.2.



=== debian/control ===
Source: dde-introduction
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends: debhelper (>= 9),
 pkg-config,
 cmake,
 libgsettings-qt-dev,
 qtbase5-dev,
 qttools5-dev-tools,
 qttools5-dev,
 qtbase5-private-dev,
 libqt5svg5-dev,
 qtwebengine5-dev,
 libdtkwidget-dev,
 libdtkgui-dev,
 libdtkcore-dev,
 libdmr-dev,
 qtmultimedia5-dev,
 libffmpegthumbnailer-dev,
 libgtest-dev,
 libgmock-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: dde-introduction
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Introduction for UOS
 When you log into the system for the first time, a welcome program will automatically start.
 Watch the introduction video to get new features, customize your desktop, enable the window
 effect and know more about UnionTech OS.

## dde-introduction 6.5.22

=== debian/changelog ===
dde-introduction (6.5.22) unstable; urgency=medium

  * Update version to 6.5.22.

 -- Tian ShiLin <tianshilin@uniontech.com>  Mon, 23 Jun 2025 15:12:14 +0800

dde-introduction (6.5.21) unstable; urgency=medium

  * update deepin video

 -- liuzheng <uos@uos-PC>  Wed, 21 May 2025 15:01:20 +0800

dde-introduction (6.5.20) unstable; urgency=medium

  * docs: refactor single instance check(Bug: 313907)

 -- renbin <renbin@uniontech.com>  Tue, 22 Apr 2025 18:25:29 +0800

dde-introduction (6.5.19) unstable; urgency=medium

  * Update version to 6.5.19

 -- renbin <renbin@uniontech.com>  Thu, 17 Apr 2025 13:20:50 +0800

dde-introduction (6.5.18) unstable; urgency=medium

  * fix: Use DBus for system edition check

 -- renbin <renbin@uniontech.com>  Thu, 10 Apr 2025 17:02:11 +0800

## dde-introduction 6.5.23

=== debian/changelog ===
dde-introduction (6.5.23) unstable; urgency=medium

  * update version to 6.5.23.

 -- Tian ShiLin <tianshilin@uniontech.com>  Tue, 01 Jul 2025 21:03:59 +0800

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,18 @@
 Build-Depends: debhelper (>= 9),
  pkg-config,
  cmake,
- libgsettings-qt-dev,
- qtbase5-dev,
- qttools5-dev-tools,
- qttools5-dev,
- qtbase5-private-dev,
- libqt5svg5-dev,
- qtwebengine5-dev,
- libdtkwidget-dev,
- libdtkgui-dev,
- libdtkcore-dev,
- libdmr-dev,
- qtmultimedia5-dev,
+ qt6-5compat-dev | libgsettings-qt-dev,
+ qt6-base-dev | qtbase5-dev,
+ qt6-tools-dev-tools | qttools5-dev-tools,
+ qt6-tools-dev | qttools5-dev,
+ qt6-base-private-dev | qtbase5-private-dev,
+ qt6-svg-dev | libqt5svg5-dev,
+ qt6-webengine-dev | qtwebengine5-dev,
+ libdtk6widget-dev | libdtkwidget-dev,
+ libdtk6gui-dev | libdtkgui-dev,
+ libdtk6core-dev | libdtkcore-dev,
+ libdmr6-dev | libdmr-dev,
+ qt6-multimedia-dev | qtmultimedia5-dev,
  libffmpegthumbnailer-dev,
  libgtest-dev,
  libgmock-dev

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5
include /usr/share/dpkg/default.mk

# 检测当前安装的Qt版本，优先使用Qt6，否则使用Qt5
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

# hardcode this if want to force build with sepecific Qt version
# QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SAFETYTEST_ARG="CMAKE_SAFETYTEST_ARG_OFF" \
	-DVERSION=$(DEB_VERSION_UPSTREAM) \
	-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DQT_DIR=$(QT_DIR)

## dde-introduction 6.5.25

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,13 +29,12 @@
 #set different ISO types
 #1:professional 2:community 3:server
 #set(ISO_TYPE "professional")
-set(ISO_TYPE "community")
+# set(ISO_TYPE "community")
 #set(ISO_TYPE "server")
 
 #common resource names
 set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/resources")
 set(APP_BIN_NAME "dde-introduction")
-set(APP_TRANS_SCRIPT "${CMAKE_SOURCE_DIR}/translate_generation.sh")
 set(APP_DESKTOP "${CMAKE_SOURCE_DIR}/dde-introduction.desktop")
 set(APP_QRC "${CMAKE_SOURCE_DIR}/dde-introduction.qrc")
 set(APP_LOGO "${APP_RES_DIR}/dde-introduction.svg")
@@ -57,8 +56,7 @@
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
-set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wl,--as-need -fPIE")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")
 
 #安全测试加固编译参数
@@ -73,6 +71,22 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DISLOONGARCH64")
 endif ()
 
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
+# 引入翻译生成
+include(translation-generate)
+
+# Find Qt version
+find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
+message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")
+set(QT_DESIRED_VERSION ${QT_VERSION_MAJOR})
+
+if (QT_VERSION_MAJOR MATCHES 6)
+    set(DTK_VERSION_MAJOR 6)
+else()
+    set(DTK_VERSION_MAJOR "")
+endif()
+message("   >>> Build with DTK: ${DTK_VERSION_MAJOR}")
+
 #compile flags
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
@@ -88,13 +102,6 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
 endif()
 
-execute_process(COMMAND bash
-                    ${APP_TRANS_SCRIPT}
-                    translations
-                    ${APP_TS_UPDATE}
-                    ${CMAKE_CURRENT_SOURCE_DIR}
-                    ${APP_BIN_NAME}
-                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")
 
 configure_file(${CMAKE_CURRENT_LIST_DIR}/src/environments.h.in ${CMAKE_CURRENT_LIST_DIR}/src/environments.h @ONLY)
 
@@ -122,24 +129,92 @@
 
 # Find the library
 find_package(PkgConfig REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5 COMPONENTS DBus Sql Multimedia REQUIRED)
-find_package(Qt5Gui REQUIRED)
-find_package(DtkWidget REQUIRED)
-find_package(DtkCore REQUIRED)
-find_package(DFrameworkdbus REQUIRED)
+set(qt_required_components Core DBus Gui Widgets Sql Multimedia)
+
+if (QT_DESIRED_VERSION MATCHES 6)
+    list(APPEND qt_required_components Core5Compat)
+else()
+    # list(APPEND qt_required_components X11Extras )
+endif()
+
+find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
+find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget Gui Core)
+
+set(LINK_LIBS
+    Qt${QT_DESIRED_VERSION}::Core
+    Qt${QT_DESIRED_VERSION}::DBus
+    Qt${QT_DESIRED_VERSION}::Gui
+    Qt${QT_DESIRED_VERSION}::Widgets
+    Qt${QT_DESIRED_VERSION}::Sql
+    Qt${QT_DESIRED_VERSION}::Multimedia
+    Dtk${DTK_VERSION_MAJOR}::Widget
+    Dtk${DTK_VERSION_MAJOR}::Gui
+    Dtk${DTK_VERSION_MAJOR}::Core
+)
+
+if (QT_DESIRED_VERSION MATCHES 6)
+    list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::Core5Compat)
+    # list(APPEND LINK_LIBS Qt${QT_VERSION_MAJOR}::GuiPrivate)
+else()
+    # list(APPEND LINK_LIBS Qt${QT_VERSION_MAJOR}::WidgetsPrivate)
+    # list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::X11Extras)
+endif()
 
 include_directories(${GSTREAMER_INCLUDE_DIRS})
-include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})
-
-if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
-    pkg_check_modules(LIBDMR REQUIRED libdmr)
-    include_directories(${LIBDMR_INCLUDE_DIRS})
-else()
-    ADD_DEFINITIONS("-D DISABLE_VIDEO")
-    LIST(REMOVE_ITEM CPP_SRC ${CMAKE_CURRENT_LIST_DIR}/src/modules/videowidget.cpp)
-endif()
-
+
+pkg_check_modules(LIBDMR REQUIRED libdmr)
+include_directories(${LIBDMR_INCLUDE_DIRS})
+
+# 获取 pkg-config 的搜索路径
+execute_process(
+    COMMAND pkg-config --variable pc_path pkg-config
+    OUTPUT_VARIABLE PKG_CONFIG_PATHS
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+)
+
+# 将 PKG_CONFIG_PATHS 转换为列表
+string(REPLACE ":" ";" PKG_CONFIG_PATHS "${PKG_CONFIG_PATHS}")
+
+# 查找 libdmr.pc 文件
+set(LIBDMR_PKGCONF "")
+foreach(PATH ${PKG_CONFIG_PATHS})
+    if(EXISTS "${PATH}/libdmr.pc")
+        set(LIBDMR_PKGCONF "${PATH}/libdmr.pc")
+        break()
+    endif()
+endforeach()
+message("LIBDMR_PKGCONF: ${LIBDMR_PKGCONF}")
+
+# 读取 libdmr.pc 文件的内容
+file(READ ${LIBDMR_PKGCONF} LIBDMR_PC_CONTENT)
+
+# 查找 Requires 部分
+string(REGEX MATCH "Requires: ([^\\n]+)" LIBDMR_REQUIRES "${LIBDMR_PC_CONTENT}")
+
+# 提取依赖库列表
+if(LIBDMR_REQUIRES)
+    string(REGEX REPLACE "Requires: ([^\\n]+)" "\\1" LIBDMR_REQUIRES_LIST "${LIBDMR_REQUIRES}")
+    
+    # 根据 QT_DESIRED_VERSION 检查依赖的 Qt 版本
+    if(QT_DESIRED_VERSION MATCHES 6)
+        if(LIBDMR_REQUIRES_LIST MATCHES "Qt6Widgets")
+            message(STATUS "libdmr 依赖于 Qt6")
+        else()
+            message(FATAL_ERROR "Qt6 编译， 但 libdmr 不是依赖 Qt6")
+        endif()
+    else()
+        if(LIBDMR_REQUIRES_LIST MATCHES "Qt5Widgets")
+            message(STATUS "libdmr 依赖于 Qt5")
+        else()
+            message(FATAL_ERROR "Qt5 编译， 但 libdmr 不是依赖 Qt5")
+        endif()
+    endif()
+else()
+    message(STATUS "无法从 libdmr.pc 文件中获取 Requires 部分")
+endif()
+
+pkg_check_modules(FFMPEGTHUMBNAIL REQUIRED libffmpegthumbnailer)
+include_directories(${FFMPEGTHUMBNAIL_INCLUDE_DIRS})
 
 # Tell CMake to create the executable
 add_executable(${PROJECT_NAME} ${CPP_SRC} ${APP_QRC})
@@ -148,38 +223,30 @@
     PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})
 
 target_link_libraries(${APP_BIN_NAME}
-    ${DtkCore_LIBRARIES}
-    ${DFrameworkdbus_LIBRARIES}
+    ${LINK_LIBS}
     ${GSTREAMER_LIBRARIES}
-    ${DtkWidget_LIBRARIES}
-    Qt5::Core
-    Qt5::Gui
-    Qt5::Widgets
-    Qt5::DBus
-    Qt5::Multimedia
+    ${LIBDMR_LIBRARIES}
+    ${FFMPEGTHUMBNAIL_LIBRARIES}
 )
 
-if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
-    target_link_libraries(${APP_BIN_NAME} ${LIBDMR_LIBRARIES})
-endif()
-
-
-set(CMAKE_INSTALL_PREFIX /usr)
+if(NOT CMAKE_INSTALL_PREFIX)
+    set(CMAKE_INSTALL_PREFIX "/usr")
+endif()
 
 # Install files
-install(TARGETS dde-introduction DESTINATION bin)
-
-file(GLOB APP_QM_FILES "${CMAKE_SOURCE_DIR}/translations/*.qm")
+install(TARGETS dde-introduction DESTINATION ${CMAKE_INSTALL_BINDIR})
+
 file(GLOB_RECURSE ASS_SRC ${CMAKE_SOURCE_DIR}/resources/video/*.ass)
 
 #Choose different videos for different ISO types
-if(ISO_TYPE MATCHES "server")
-set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/server/demo.mp4)
-elseif(ISO_TYPE MATCHES "community")
-set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/community/demo.mp4)
-else()
-set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/professional/demo.mp4)
-endif()
+#if(ISO_TYPE MATCHES "server")
+#set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/server/demo.mp4)
+#elseif(ISO_TYPE MATCHES "community")
+#set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/community/demo.mp4)
+#else()
+#临时代码，提供动图后需要修改！！！
+set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/2500/)
+#endif()
 
 #代码覆盖率开关
 if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
@@ -187,13 +254,18 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
 endif()
 
-file(GLOB_RECURSE DEMO_VIDEO_SRC ${VIDEO_PATH})
-
-install(FILES ${APP_QM_FILES} DESTINATION /usr/share/dde-introduction/translations)
-install(FILES ${APP_DESKTOP} DESTINATION /usr/share/applications)
+# translation files
+TRANSLATION_GENERATE(QM_FILES ${CMAKE_SOURCE_DIR}/translations)
+add_custom_target(${PROJECT_NAME}_qm_files DEPENDS ${QM_FILES})
+add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_qm_files)
+
+# Install translations
+install(FILES ${QM_FILES} DESTINATION share/${PROJECT_NAME}/translations)
+
+install(FILES ${APP_DESKTOP} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
 install(FILES ${APP_LOGO} DESTINATION  ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)
-install(FILES ${ASS_SRC} DESTINATION /usr/share/dde-introduction/)
-install(FILES ${DEMO_VIDEO_SRC} DESTINATION /usr/share/dde-introduction/)
+install(FILES ${ASS_SRC} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dde-introduction/)
+install(DIRECTORY ${VIDEO_PATH} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dde-introduction/)
 #add ut test
 #add_subdirectory(tests)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -22,9 +22,40 @@
 ADD_COMPILE_OPTIONS(-fno-access-control)
 
 # 设置添加gocv相关信息的输出
-set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
 
-find_package(Qt5Test REQUIRED)
+set(qt_required_components Core DBus Gui Widgets Sql Multimedia Test)
+
+if (QT_DESIRED_VERSION MATCHES 6)
+    list(APPEND qt_required_components Core5Compat)
+else()
+    # list(APPEND qt_required_components X11Extras )
+endif()
+
+find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
+find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget Gui Core)
+
+set(LINK_LIBS
+    Qt${QT_DESIRED_VERSION}::Core
+    Qt${QT_DESIRED_VERSION}::DBus
+    Qt${QT_DESIRED_VERSION}::Gui
+    Qt${QT_DESIRED_VERSION}::Widgets
+    Qt${QT_DESIRED_VERSION}::Sql
+    Qt${QT_DESIRED_VERSION}::Multimedia
+    Qt${QT_DESIRED_VERSION}::Test
+    Dtk${DTK_VERSION_MAJOR}::Widget
+    Dtk${DTK_VERSION_MAJOR}::Gui
+    Dtk${DTK_VERSION_MAJOR}::Core
+)
+
+if (QT_DESIRED_VERSION MATCHES 6)
+    list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::Core5Compat)
+    # list(APPEND LINK_LIBS Qt${QT_VERSION_MAJOR}::GuiPrivate)
+else()
+    # list(APPEND LINK_LIBS Qt${QT_VERSION_MAJOR}::WidgetsPrivate)
+    # list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::X11Extras)
+endif()
+
 find_package(GTest REQUIRED)
 include_directories(${GTEST_INCLUDE_DIRS})
 include_directories(src)
@@ -58,18 +89,11 @@
 
 # 生成测试可执行程序的依赖库QApplication
 target_link_libraries(${PROJECT_NAME_TEST} 
-    ${DtkWidget_LIBRARIES}
-    ${DtkCore_LIBRARIES}
-    ${DFrameworkdbus_LIBRARIES}
+    ${LINK_LIBS}
     ${GSTREAMER_LIBRARIES}
     ${LIBDMR_LIBRARIES}
     ${GTEST_LIBRARYS}
     ${GTEST_MAIN_LIBRARYS}
-    Qt5::Core
-    Qt5::Gui
-    Qt5::Widgets
-    Qt5::DBus
-    Qt5::Multimedia
     gtest
     gtest_main
     -pthread
@@ -81,9 +105,9 @@
     target_link_libraries(${PROJECT_NAME_TEST} ${LIBDMR_LIBRARIES})
 endif()
 
-target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${DtkWidget_INCLUDE_DIRS}
-                                                       ${DtkCore_INCLUDE_DIRS}
-                                                       ${DtkGui_INCLUDE_DIRS})
+# target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${DtkWidget_INCLUDE_DIRS}
+#                                                        ${DtkCore_INCLUDE_DIRS}
+#                                                        ${DtkGui_INCLUDE_DIRS})
 
 # ------------------------------ 创建'make test'指令---------------------------------------
 add_custom_target(test)

=== debian/changelog ===
dde-introduction (6.5.25) unstable; urgency=medium

  * update version to 6.5.25

 -- zhanghongyuan <zhanghongyuan@uniontech.com>  Thu, 16 Oct 2025 19:43:57 +0800

dde-introduction (6.5.24) unstable; urgency=medium

  *Update version to 6.5.24.

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 07 Aug 2025 19:01:08 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Deepin Packages Builder <packages@deepin.org>
 Build-Depends: debhelper (>= 9),
- pkg-config,
  cmake,
  qt6-5compat-dev | libgsettings-qt-dev,
  qt6-base-dev | qtbase5-dev,

## dde-introduction 7.0.4

=== CMakeLists.txt ===
# Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
#
# Author:     V4fr3e <V4fr3e@deepin.io>
#
# Maintainer: V4fr3e <liujinli@uniontech.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.7)
set(PROJECT_VERSION "5.9.0.53")

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

ADD_COMPILE_OPTIONS(-fno-access-control)

#set different ISO types
#1:professional 2:community 3:server
#set(ISO_TYPE "professional")
set(ISO_TYPE "community")
#set(ISO_TYPE "server")

#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/resources")
set(APP_BIN_NAME "dde-introduction")
set(APP_TRANS_SCRIPT "${CMAKE_SOURCE_DIR}/translate_generation.sh")
set(APP_DESKTOP "${CMAKE_SOURCE_DIR}/dde-introduction.desktop")
set(APP_QRC "${CMAKE_SOURCE_DIR}/dde-introduction.qrc")
set(APP_LOGO "${APP_RES_DIR}/dde-introduction.svg")

#Check if APP_TS_UPDATE var isn't set, don't need update ts file
if (NOT DEFINED APP_TS_UPDATE)
   set(APP_TS_UPDATE false)
endif()

#Only update ts file when APP_TS_UPDATE=true
if (${APP_TS_UPDATE} STREQUAL "true")
    set(APP_TS_UPDATE true)
endif()

project(${APP_BIN_NAME})

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
elseif (${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DISLOONGARCH64")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

execute_process(COMMAND bash
                    ${APP_TRANS_SCRIPT}
                    translations
                    ${APP_TS_UPDATE}
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${APP_BIN_NAME}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${CMAKE_CURRENT_LIST_DIR}/src/environments.h.in ${CMAKE_CURRENT_LIST_DIR}/src/environments.h @ONLY)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/src)

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/${subdir})
endforeach()

file(GLOB_RECURSE CPP_SRC ${CMAKE_SOURCE_DIR}/src/*.cpp)


# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5 COMPONENTS DBus Sql Multimedia REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkCore REQUIRED)
find_package(DFrameworkdbus REQUIRED)

include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    pkg_check_modules(LIBDMR REQUIRED libdmr)
    include_directories(${LIBDMR_INCLUDE_DIRS})
else()
    ADD_DEFINITIONS("-D DISABLE_VIDEO")
    LIST(REMOVE_ITEM CPP_SRC ${CMAKE_CURRENT_LIST_DIR}/src/modules/videowidget.cpp)
endif()


# Tell CMake to create the executable
add_executable(${PROJECT_NAME} ${CPP_SRC} ${APP_QRC})

target_include_directories(${APP_BIN_NAME}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})

target_link_libraries(${APP_BIN_NAME}
    ${DtkCore_LIBRARIES}
    ${DFrameworkdbus_LIBRARIES}
    ${GSTREAMER_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Multimedia
)

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    target_link_libraries(${APP_BIN_NAME} ${LIBDMR_LIBRARIES})
endif()


set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(TARGETS dde-introduction DESTINATION bin)

file(GLOB APP_QM_FILES "${CMAKE_SOURCE_DIR}/translations/*.qm")
file(GLOB_RECURSE ASS_SRC ${CMAKE_SOURCE_DIR}/resources/video/*.ass)

#Choose different videos for different ISO types
if(ISO_TYPE MATCHES "server")
set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/server/demo.mp4)
elseif(ISO_TYPE MATCHES "community")
set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/community/demo.mp4)
else()
set(VIDEO_PATH ${CMAKE_SOURCE_DIR}/resources/video/professional/demo.mp4)
endif()

#代码覆盖率开关
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

file(GLOB_RECURSE DEMO_VIDEO_SRC ${VIDEO_PATH})

install(FILES ${APP_QM_FILES} DESTINATION /usr/share/dde-introduction/translations)
install(FILES ${APP_DESKTOP} DESTINATION /usr/share/applications)
install(FILES ${APP_LOGO} DESTINATION  ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)
install(FILES ${ASS_SRC} DESTINATION /usr/share/dde-introduction/)
install(FILES ${DEMO_VIDEO_SRC} DESTINATION /usr/share/dde-introduction/)
#add ut test
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(tests)
endif()
#add_subdirectory(tests)

=== debian/changelog ===
dde-introduction (7.0.4) unstable; urgency=medium

  * 7.0.4

 -- Wang Fei <wangfei@deepin.org>  Fri, 26 Apr 2024 10:31:33 +0800

dde-introduction (7.0.3) unstable; urgency=medium

  * 7.0.3

 -- Wang Fei <wangfei@deepin.org>  Fri, 19 Apr 2024 17:27:26 +0800

dde-introduction (6.0.7) unstable; urgency=medium

  * update changelog .

 -- xiepengfei xiepengfei@uniontech.com>  Mon, 11 Sep 2023 14:48:21 +0800

dde-introduction (6.0.6) unstable; urgency=medium

  * update cmake .

 -- LiChengGang <lichenggang@uniontech.com>  Fri, 12 May 2023 18:03:43 +0800

dde-introduction (6.0.5) unstable; urgency=medium

 * New version 6.0.5.

 --  <xiepengfei@uniontech.com>  Mon, 16 Jan 2023 17:33:00 +0800

dde-introduction (6.0.4) unstable; urgency=medium

 * New version 6.0.4.

 --  <xiepengfei@uniontech.com>  Wed, 4 Jan 2023 10:30:00 +0800

dde-introduction (6.0.3) UNRELEASED; urgency=medium

 * Video material update.

 --  <liuzheng@uniontech.com>  Tues, 13 Des 2022 13:23:00 +0800

dde-introduction (6.0.2) UNRELEASED; urgency=medium

 * Modify icon theme DBUS.

 --  <xiepengfei@uniontech.com>  Tues, 11 Nov 2022 15:23:00 +0800

dde-introduction (6.0.1) UNRELEASED; urgency=medium

 * Video material update.

 --  <xiepengfei@uniontech.com>  Thur, 17 Spet 2022 11:17:00 +0800

dde-introduction (5.6.35+u0001) UNRELEASED; urgency=medium

 * Non-maintainer upload.

 --  <xuezifan@xuezifan-PC>  Tue, 17 May 2022 07:27:20 +0800

dde-introduction (5.6.35) unstable; urgency=medium

 * 修复snipe分支打包报错问题；

-- Deepin Packages Builder <packages@deepin.com>  Wed, 11 Oct 2017 17:38:35 +0800
